<?php
/*
  Plugin Name: Woocommerce Hide Add To Cart Button
  Description: This is Hide Add To Cart Button plugin
  Version: 1.0
  Author: WPProcare
 */
 
 // add jQuery UI
function hatcb_jquery_ui() {
    wp_register_style('jquery_ui' , plugin_dir_url(__FILE__). 'css/jquery-ui-timepicker-addon.css');
    wp_enqueue_style('jquery_ui');	
    wp_enqueue_script('jquery-time-picker' ,  plugin_dir_url(__FILE__). 'js/jquery-ui-timepicker-addon.js',  array('jquery' ));
    wp_enqueue_script('custom' ,  plugin_dir_url(__FILE__). 'js/custom_backend.js',  array('jquery' ));	
}
add_action('admin_head', 'hatcb_jquery_ui');

function hatcb_scripts() {
        wp_register_style('jquery_ui' , plugin_dir_url(__FILE__). 'css/custom_frontend.css');
        wp_enqueue_script('theme_name_scripts', plugin_dir_url(__FILE__) . 'js/custom_frontend.js', array('jquery'), '1.0', true);
}
add_action( 'wp_enqueue_scripts', 'hatcb_scripts' );

// Add Custom Product Fileds
add_action('woocommerce_product_options_general_product_data', 'hatcb_woocommerce_custom_product_data_field');
if (!function_exists('hatcb_woocommerce_custom_product_data_field')) {
    function hatcb_woocommerce_custom_product_data_field() {
        global $woocommerce, $post;
        echo '<div class="options_group">';
        woocommerce_wp_select(
                array(
                    'id' => 'woo_disable_add_to_cart_checkbox',
                    'label' => __('Show/Hide Add to Cart Button', 'woocommerce'),
                    'options' => array(
                        'show_button' => __('Show', 'woocommerce'),
                        'disable_button' => __('Hide', 'woocommerce'),
                    )
                )
        );
        woocommerce_wp_text_input(
            array(
                'id' => 'woo_disable_add_to_cart_date',
                'label' => __('Expiry date', 'woocommerce'),
                'type' => 'text', 
                )
        );
        echo '</div>';
    }
}

// Save Custom Product Fields
add_action('woocommerce_process_product_meta', 'hatcb_woo_process_product_meta_fields_save');
/**
 * Product Meta Fields Save
 * @param type $post_id
 */
if (!function_exists('hatcb_woo_process_product_meta_fields_save')) {
    function hatcb_woo_process_product_meta_fields_save($post_id) {
    	$woocheckbox=sanitize_text_field($_POST['woo_disable_add_to_cart_checkbox']);
        $woo_disable_add_to_cart_checkbox = isset($woocheckbox) ? $woocheckbox : 'Show';
        update_post_meta($post_id, 'woo_disable_add_to_cart_checkbox', $woo_disable_add_to_cart_checkbox);
        
        $woocommerce_text_field = sanitize_text_field($_POST['woo_disable_add_to_cart_date']);
        update_post_meta( $post_id, 'woo_disable_add_to_cart_date', esc_attr( $woocommerce_text_field ) );
    }
}

//
add_action( 'woocommerce_after_shop_loop_item','hatcb_add_custom_field_into_loop',11);
function hatcb_add_custom_field_into_loop(){
    global $product;
    $show_hide_option = get_post_meta( $product->id, 'woo_disable_add_to_cart_checkbox', 'false' );
    $show_hide_datetime = get_post_meta( $product->id, 'woo_disable_add_to_cart_date', 'false' );
    
    $st_dt = new DateTime($show_hide_datetime); 
    $set_time = $st_dt->format('Y-m-d H:i:s');
    $current_time = current_time( 'mysql' ); 
    
    if($show_hide_option == 'show_button'){
        //  
    }else if($show_hide_option == 'disable_button'){
        if($set_time>=$current_time){
        echo '<div class="hide-add-cart"></div>';
        ?>
        <style>
            ul.products > li.post-<?php echo $product->id; ?> a.button{display:none !important}
        </style>
        <?php
        }
    }
}

add_action( 'woocommerce_single_product_summary','hatcb_add_custom_field_into_single',31 );
function hatcb_add_custom_field_into_single(){
    global $product;
    $show_hide_option = get_post_meta( $product->id, 'woo_disable_add_to_cart_checkbox', 'false' );
    $show_hide_datetime = get_post_meta( $product->id, 'woo_disable_add_to_cart_date', 'false' );
    
    $st_dt = new DateTime($show_hide_datetime); 
    $set_time = $st_dt->format('Y-m-d H:i:s');
    $current_time = current_time( 'mysql' ); 
    if($show_hide_option == 'show_button'){
          
    }else if($show_hide_option == 'disable_button'){
        if($set_time>=$current_time){
        echo '<div class="hide-add-cart-2"></div>';
        ?>
        <style>
            #product-<?php echo $product->id; ?> div.summary.entry-summary form.cart{display:none !important}
        </style>
        <?php
        }
    }
}